.\" $Id: xmotd.8,v 1.4 1997/09/12 20:44:58 elf Exp $"
.TH XMOTD 8 "Sep 12 1997" "X11 Release 6.3"
.SH NAME
xmotd \- message-of-the-day browser for X (and dumb terminals,
VT100, etc.)

.SH SYNOPSIS
.B xmotd 
[\fIX-toolkit options\fP] [-always] [-bitmaplogo
\fIbitmap-filename\fP] [-browser \fIweb-browser\fP] [-help]
[-stampfile \fIstamp-filename\fP] [-showfilename] [-usedomains]
[-wakeup \fIsleep-period\fP] [-warnfile \fIwarning-filename\fP
[-paranoid]] [-popdown \fItimeout\fP] \fImotd-filename\fP
[\fImotd-filename2\fP ... ]

.LP
or
.LP

.B xmotd 
xmotd-options \fImotd-directoryname\fP

.LP
or (in text-mode)
.LP

.B xmotd
[-stampfile \fIstamp-filename\fP] [-wakeup \fIsleep-period\fP] \fImotd-filename\fP [\fImotd-filename2\fP ...]

.SH DESCRIPTION
.LP
\fIxmotd\fP is a message-of-the-day browser for X11 and dumb
terminals. Under X11, it displays a customizable bitmap in the
top-left corner. It provides for up to 3 lines of title-text (the
length of the text depends on the size of the font chosen). It has a
\fI"Dismiss"\fP button below the bitmap and a read-only text-widget
that displays the message (or messages) of the day. The date of the
message (and optionally, the filename) is displayed just above the
text.


.LP
\fIxmotd\fP can be configured to run in various modes: to always
pop-up after login or to pop-up only when the motd changes; to
pop-down automatically (without user-intervention) after a specified
delay; to run in the background and periodically check if the motd
has changed and display it. By default, \fIxmotd\fP displays a
message only if the file(s) was updated since the last time the user
read it.

.LP
If \fIxmotd\fP has to display more than one file, the user is
required to press the \fI"Next Message"\fP button to view subsequent
messages; the text of the button changes to \fI"Dismiss"\fP when the
last message is displayed.

.LP
\fIxmotd\fP defaults to text-only mode (output to \fIstdout\fP) when
it cannot connect to an X display. This mode is useful for running
\fIxmotd\fP from user's \fI~/.login\fP file in cases where they can
also login via dialup.

.LP
\fIxmotd\fP can display messages marked-up with HTML and xpm colour
pixmap logos. Support for these must be configured at compile-time.

.SH OPERATION
.LP
\fIxmotd\fP is usually run from the system \fIXsession\fP file via
xdm(1) and/or from the user's \fI~/.login\fP file. At sites where xdm
is not used, \fIxmotd\fP may be run from the user's \fI~/.xinitrc\fP
where a (possibly) malicious user may intentionally or accidently
remove the \fIxmotd\fP invocation from the file.

.LP
When \fIxmotd\fP first runs, it creates a timestamp file (by default
called \fI.xmotd\fP) in the user's home-directory. On subsequent
invocations, \fIxmotd\fP uses the date of this file to decide whether
or not the message-of-the-day (motd) files have been updated. If the
date of the motd file is later than the date on the \fI~/.xmotd\fP
file, then \fIxmotd\fP will display the motd file; otherwise it will
silently exit (if there are no more files to be displayed and if
\fI-wakeup\fP was not used). When invoked with \fI-wakeup\fP, xmotd
daemonizes itself and goes to sleep for the specified sleep-period,
periodically waking-up to see if the motds have changed and then
displaying them.

.LP
In cases where user's home-directories are shared (NFS mounted)
across various (unique) domains, \fIxmotd\fP supports domain-name
based time-stamping by creating timestamps with the appropriate
domain-names appended and checks the dates of these timestamps with
the date of the message-of-the-day file(s).

.LP
By default, \fIxmotd\fP pops-down only when the \fI"Dismiss"\fP
button is clicked; the rest of the login-procedure then
continues. This interactive behaviour can be overriden so \fIxmotd\fP
will pop-down without user intervention, after a specified timeout
period.

.SH OPTIONS
All the standard \fIX\fP options are valid. In addition, the
following options, which may also be set as resources in the
app-defaults file (See RESOURCES), are available:

.TP 8
-always

overrides \fIxmotd\fP's "smart" behavior; the \fI~/.xmotd\fP
time-stamp is ignored and the message (or messages) is always
displayed. Zero-length (empty) files are displayed when this option
is specified.

.TP 8
-bitmaplogo \fIbitmap-filename\fP 

specifies that the bitmap \fIbitmap-filename\fP is to be displayed in
place of the default bitmap, the "X" logo.  Ideally, the specified
bitmap should have a width and height of 100 pixels. If xpm support
is compiled-in, xpm colour pixmaps may be substituted instead. See
NOTES for additional details.

.TP 8
-browser \fIweb-browser\fP 

specifies the path and filename of a browser to be used when an URL
is clicked (HTML version only). The default is
\fI"/usr/local/bin/netscape"\fP. See NOTES for additional details.

.TP 8
-help

prints detailed command-line usage.

.TP 8
-paranoid

(used with \fI-warnfile\fP) displays the warning message
unconditionally at every login (even when there are no messages to be
displayed).

.TP 8
-popdown \fItimeout\fP 

indicates that \fIxmotd\fP should exit/pop-down without user
intervention, \fItimeout\fP seconds after being invoked. The user can
dismiss \fIxmotd\fP at any time before the timeout, by clicking on
the \fI"Dismiss"\fP button. This option is only valid at the initial
login; it is ignored on subsequent pop-ups when \fIxmotd\fP is
invoked with \fI-wakeup\fP.

.TP 8
-showfilename

displays the filename (as it appears on the command-line), of the
file currently being viewed, alongside the date.

.TP 8
-stampfile \fIstamp-filename\fP 

overrides the default timestamp filename, \fI~/.xmotd\fP and uses
\fIstamp-filename\fP instead.


.TP 8
-usedomains

uses local domain-name based time-stamping in cases where user's
home-directories are shared (NFS mounted) across various domains.
Time-stamps are created (and checked) with appropriate domain-names
appended.

.TP 8
-warnfile \fIwarning-filename\fP

specifies a file containing a standard message used to warn users of
the consequences of deviance and sundry unlawful things they should
not even \fIthink\fP of doing on your network; your network's rules of
use, information about disk quotas, modem charges and printer
accounting fees (used with \fI-paranoid\fP option).

.TP 8
-wakeup \fIsleep-period\fP 

causes \fIxmotd\fP to run in the background and wakeup periodically
every \fIsleep-period\fP hours to check whether the message(s) on the
command-line have been modified and therefore need to be
(re-)displayed. The sleep period is specified as a floating point
number where the fractional portion indicates the number of
minutes. For example, a sleep-period of 0.25 indicates 15 minutes
(one quarter of an hour) and a sleep-period of 1.5 indicates one and
one-half hours; the minimum (enforced) sleep-period is 1 minute. The
\fI-wakeup\fP option is useful at sites where users have their own
workstations never log-out. See NOTES for additional details.

.TP 8
\fImotd-filename [motd-filename2 ... ]\fP 

one or more files to be displayed may be specified. The file(s)
contain the text of the message(s) of the day. If HTML support is
compiled-in the motd files should be marked-up with HTML.

.TP 8
\fImotd-directoryname\fP 

Instead of supplying one or more files on the command-line,
\fIxmotd\fP may be supplied a directory-name containing file(s) to be
displayed. \fIxmotd\fP will scan the directory and display all the
files contained therein, that need to be displayed. This feature is
useful when used with the \fI-wakeup\fP option; upon waking-up,
\fIxmotd\fP will re-scan the directory for any files (including new
files that have been subsequently added) that need to be displayed.

.SH EXAMPLES
.LP
Give \fIxmotd\fP a geometry option to tell it to pop-up at a location
other than 0,0 and read-in the message-of-the-day from the file
\fI/usr/local/motd\fP:
.nf

   xmotd -geometry +20+20 /usr/local/motd
.fi
.LP
Use a bigger window (900x600) and automatically position it (at
top-left corner at 20,20), always pop-up \fIxmotd\fP displaying the
contents of \fI/usr/local/motd\fP, ignoring the user's \fI~/.xmotd\fP
timestamp-file and pop-down after 20 seconds:
.nf

   xmotd -geom 900x600+20+20 -always -popdown 20 /usr/local/motd
.fi

.LP
Use a custom bitmap as the logo (the bitmap is in the file
\fI/usr/local/xmotd.bm\fP):
.nf

   xmotd -geom +5+5 -bitmaplogo /usr/local/xmotd.bm /usr/local/motd
.fi

.LP
In the following example, all the files in \fI/usr/local/messages/\fP will
be checked for modification times greater than the time-stamp and
only those files will be displayed and every eight and a half hours,
\fIxmotd\fP will check if any files have changed (or new ones added)
and display them if necessary:
.nf

   xmotd -geom +5+5 -wakeup 8.5 /usr/local/messages/ 
.fi

To display a warning-message every time the user logs-in (even when
no messages need to be displayed), and to display the filenames of
the files being viewed, use:
.nf

   xmotd -geom +5+5 -warnfile /usr/local/WARNING -paranoid \\
      -showfilename /usr/local/motds/
.fi

X resources may be changed from the command-line using the \fI-xrm\fP
option. This example (typed as a single line) illustrates how
\fIxmotd\fP can be customized exclusively from the command-line:

.nf

    /usr/X11/bin/xmotd -always \\
        -xrm "*title.label: Top 10 Disk Hogs\n As of midnight\n " \\
        -xrm "*title.foreground: yellow" \\
        -xrm "*form.background: red" \\
        -xrm "*title.background: red" \\
        -xrm "*logo.background: pink" \\
        -xrm "*text*font: -adobe-times-bold-*-normal-*-*-180-*" \\
        -geometry 500x650-1-1 \\
        -bitmaplogo /usr/common/choke.xbm 
        -popdown 10 \\
        /usr/common/accounting/top &

.fi

.SH RESOURCES
The application class-name is XMotd.

.LP
The resource: \fIXMotd*Always\fP (set to either \fITrue\fP or
\fIFalse\fP) is equivalent to the \fI-always\fP command-line option.

.LP
The resource: \fIXMotd*Popdown\fP (set to the number of seconds) is
equivalent to the \fI-popdown\fP command-line option.

.LP
The resource: \fIXMotd*Browser\fP (set to the path and filename of
the browser to be used when users click on an URL (HTML version
only)) is equivalent to the \fI-browser\fP command-line option.

.LP
The resource: \fIXMotd*BitmapLogo\fP (set to the path and filename of
the bitmap/pixmap-file) is equivalent to the \fI-bitmaplogo\fP
command-line option.

.LP
The resource: \fIXMotd*UseDomains\fP (set to \fITrue/False\fP) is
equivalent to the \fI-usedomains\fP command-line option.

.LP
The resource: \fIXMotd*ShowFilename\fP ((set to \fITrue/False\fP) is
equivalent to the \fI-showfilename\fP command-line option.

.LP
The resource: \fIXMotd*Paranoid\fP ((set to \fITrue/False\fP) is
equivalent to the \fI-paranoid\fP command-line option.

.LP
The resource: \fIXMotd*Warnfile\fP (set to the path and filename of
the warning-file) is equivalent to the \fI-warnfile\fP command-line
option.

.LP
The resource: \fIXMotd*Wakeup\fP (set to an floating-point number
representing hours) is equivalent to the \fI-wakeup\fP command-line
option.

.LP
The resource: \fIXMotd*title.label\fP (set to a possibly multi-line
string) may be used to customize the title).

By default, the title is the single line:\fI"Message Of The
Day\\n\\n\\n"\fP (the 2-character sequence, \fI"\\n"\fP, indicates a
carriage-return).

For example, if you want a 2 line title that reads:
.nf

         This is the
      Message of the Day
.fi

the resource can be specified as:
.nf

       *title.label: \\       This is the\\nMessage of the Day\\n\\n
.fi

Note that the first backslash quotes the leading spaces that indent
the words, \fI"This is the"\fP.


.SH WIDGET HIERARCHY
The widget hierarchy is as follows (Class-name & object-name):
.nf
.ta .5i 1.0i 1.5i 2.0i
XMotd xmotd 
        Form form
            Label logo
            Label title
            Label hline
            Label info
            Command quit 
            Text text     OR       Html text
.fi

.SH FILES
\fI$ProjectRoot/lib/X11/xdm/Xsession\fP 

(where \fI$ProjectRoot\fP is \fI/usr/X11R6\fP or, perhaps \fI/usr/X11\fP). 

\fI$HOME/.xmotd\fP (default stamp-file)

\fI$HOME/.login\fP

.SH SEE ALSO
X(1), xdm(1), login(1), xv(l), gimp(l), xpaint(l), cat(1), less(l)

.SH NOTES

The \fI-always\fP option is considered fascist; it is provided merely
for completeness and for testing purposes.

If xpm support is compiled-in, \fIxmotd -help\fP will print the words
"bitmap/pixmap" for the \fI-bitmaplogo\fP description  instead of
just "bitmap".

Under dumb-terminal mode, all command-line options are ignored with
the exception of \fI-stampfile\fP and \fI-wakeup\fP; the
\fI-always\fP option is equivalent to cat'ing the motd from the
\fI~/.login\fP file; and \fI-popdown\fP is not really relevant. Both
\fI-warnfile\fP and \fI-paranoid\fP may be simulated with appropriate
cat(1) and more(1) commands.

\fIxmotd\fP processes invoked with \fI-wakeup\fP will continue
sleeping, "S" in the ps(1) status field, after the user has
logged-out until the sleep timeout expires. Only when \fIxmotd\fP
wakes-up, will it will detect that the user has logged-out and
exit. \fIxmotd\fP's logout-detection routine relies on the xdm(1)
support scripts \fIGiveConsole\fP and \fITakeConsole\fP setting the
correct permissions and ownership on \fI/dev/console\fP. When
\fIxmotd\fP wakes-up, it attempts to open(2) \fI/dev/console\fP for
reading; if this open fails, it indicates that the user has logged
out because \fITakeConsole\fP has changed ownership of the console.

The \fI-browser\fP option was originally called \fI-netscape\fP; it
was renamed to be more generic. When initially run, the browser is
invoked as:

.nf
    "/usr/local/bin/netscape %s"

.fi

where \fI%s\fP is replaced by the selected URL. Subsequent URLs will
be displayed in the already running browser using the syntax:

.nf
    "/usr/local/bin/netscape -remote openURL(%s)"

.fi

You may substitute a browser of your choice for netscape, if it
supports this syntax.

.SH BUGS

At least one.

Also, there are no provisions for displaying embedded images in the
HTML version of \fIxmotd\fP.

.SH QUOTES
.nf

                \fIand our lives are forever changed
                      we will never be the same
                the more you change the less you feel\fP

               --\fITonight, tonight\fP,
               "Mellon Collie And The Infinite Sadness"
               Billy Corgan, The Smashing Pumpkins


             \fIOmnia mutantur, nos et mutamur in illis.
          (All things change, and we change with them).\fP

               --Matthias Borbonius:
               \fIDeliciae Poetarum Germanorum\fP, i. 685


                 \fITo everything there is a season,
            And a time to every purpose under heaven.\fP

               --Ecclesiastes 3:1-4
.fi


.SH AUTHORS
Luis Fernandes <elf@ee.ryerson.ca> is the primary author and maintainer.

Richard Deal <rdeal@atl.lmco.com> contributed the directory-scanning code.

Stuart A. Harvey <sharvey@primenet.com> contributed the URL support
code for the HTML version.

David M. Ronis <ronis@onsager.chem.mcgill.ca> contributed code to support
xpm logos.

.SH COPYRIGHT

Copyright 1993 (as xbanner, no public release) 1994-97, Luis A.
Fernandes 

Permission to use, copy, hack, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear in
supporting documentation.

This application is presented as is without any implied or written
warranty.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The HTML widget Copyright 1993, Board of Trustees of the
University of Illinois. See the file libhtmlw/HTML.c for the complete
text of the NCSA copyright.

